#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/AlphunumClick/AlphanumClick.c"









sbit TLC5926_LE2 at LATE.B1;
sbit TLC5926_LE1 at LATE.B0;
sbit TLC5926_NS at LATD.B0;
sbit TLC5926_nNS at LATC.B0;


unsigned temp = 0;

unsigned int cnt = 0;
unsigned int wait_time;

const unsigned int CharTable[51]={
#line 38 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/AlphunumClick/AlphanumClick.c"
 0x0300,
 0x4000,
 0x2176,
 0x003F,
 0x0006,
 0x031B,
 0x030F,
 0x0000,
 0x032D,
 0x033D,
 0x0007,
 0x033F,
 0x032F,
 0x1040,
 0x0840,
 0x0480,
 0x0776,
 0x2800,
 0x1223,
 0x027B,
 0x0337,
 0x124F,
 0x0039,
 0x104F,
 0x0339,
 0x0331,
 0x023D,
 0x0336,
 0x1040,
 0x001E,
 0x05B0,
 0x0038,
 0x20B6,
 0x2436,
 0x003F,
 0x0333,
 0x443F,
 0x0733,
 0x032D,
 0x1063,
 0x003E,
 0x08B0,
 0x0C36,
 0x2C80,
 0x3080,
 0x0889,
 0x0039,
 0x0880,
 0x000F,
 0x0081,
 0x0008,
};





void InitTimer3(){
 T3CON = 0x11;
 TMR3IF_bit = 0;
 TMR3H = 0x63;
 TMR3L = 0xC0;
 TMR3IE_bit = 1;
 INTCON = 0xC0;
}

void Interrupt(){
 if (TMR3IF_bit){
 TMR3IF_bit = 0;
 TMR3H = 0x63;
 TMR3L = 0xC0;
 TLC5926_nNS = ~TLC5926_nNS;
 }
}

unsigned int intro_text[10]={
 0x003F, 0x003F,
 0x003F, 0x003F,
 0x003F, 0x003F,
 0x003F, 0x003F,
 0x003F, 0x003F
};

void settle(void){
 Delay_us(5);
}

void WriteSegments(unsigned int a, unsigned int b){

 TLC5926_LE1 = 1;
 TLC5926_LE2 = 1;
 TLC5926_NS = 1;
 TLC5926_nNS = 1;

 SPI1_Write(b >> 8);
 SPI1_Write(b & 0xff);

 TLC5926_LE1 = 0;
 settle();
 TLC5926_LE1 = 1;
 TLC5926_NS = 0;
 settle();
 TLC5926_NS = 1;

 SPI1_Write(a >> 8);
 SPI1_Write(a & 0xff);

 TLC5926_LE2 = 0;
 settle();
 TLC5926_LE2 = 1;
 TLC5926_nNS = 0;
 settle();
 TLC5926_nNS = 1;

 TLC5926_LE1 = 0;
 settle();
 TLC5926_LE1 = 1;
 TLC5926_NS = 0;
 settle();
 TLC5926_NS = 1;
}

unsigned int GetChar(char Character){
 if ((Character >= '-') && (Character <= '_')){
 return CharTable[Character - '-'];
 }
 else{
 return 0;
 }
}

unsigned int GetDigit(unsigned char Digit){
 if ((Digit >= 0) && (Digit <= 9)){
 return CharTable[Digit+3];
 }
 else{
 return 0;
 }
}

void Intro() {
 WriteSegments(0xFFFF, 0xFFFF);
 Delay_ms(70);

 for(cnt=15 ; cnt > 0 ; cnt--){
 temp += ldexp(1, cnt);
 WriteSegments(temp,temp);
 Delay_ms(300);
 }
 Delay_ms(100);
}
#line 208 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/AlphunumClick/AlphanumClick.c"
void WriteText() {
 WriteSegments(GetChar('M'), GetChar('I'));
 delay_ms(300);
 WriteSegments(GetChar('I'), GetChar('K'));
 delay_ms(300);
 WriteSegments(GetChar('K'), GetChar('R'));
 delay_ms(300);
 WriteSegments(GetChar('R'), GetChar('O'));
 delay_ms(300);
 WriteSegments(GetChar('O'), GetChar('E'));
 delay_ms(300);
 WriteSegments(GetChar('E'), GetChar('L'));
 delay_ms(300);
 WriteSegments(GetChar('L'), GetChar('E'));
 delay_ms(300);
 WriteSegments(GetChar('E'), GetChar('K'));
 delay_ms(300);
 WriteSegments(GetChar('K'), GetChar('T'));
 delay_ms(300);
 WriteSegments(GetChar('T'), GetChar('R'));
 delay_ms(300);
 WriteSegments(GetChar('R'), GetChar('O'));
 delay_ms(300);
 WriteSegments(GetChar('O'), GetChar('N'));
 delay_ms(300);
 WriteSegments(GetChar('N'), GetChar('I'));
 delay_ms(300);
 WriteSegments(GetChar('I'), GetChar('K'));
 delay_ms(300);
 WriteSegments(GetChar('K'), GetChar('A'));
}

void WriteSpecialChars(){
 delay_ms(3000);
 WriteSegments(0x2809, 0x136D);
 delay_ms(3000);
 WriteSegments(0xFFFF, 0x3CC0);
 delay_ms(3000);
 WriteSegments(0x0480, 0x2800);
 delay_ms(3000);
}

void WriteNumbers(){
 delay_ms(1000);
 WriteSegments(GetDigit(0), GetDigit(1));
 delay_ms(3000);
 WriteSegments(GetDigit(1), GetDigit(2));
 delay_ms(3000);
 WriteSegments(GetDigit(2), GetDigit(3));
 delay_ms(3000);
}


void main() {
 unsigned char i = 0;
 unsigned char SPIN_Screen = 1;
 unsigned temp = 0;

 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
 TRISA = 0;
 TRISB = 0x03;
 TRISC = 0x02;
 TRISD = 0;
 TRISE = 0;

 InitTimer3();

 wait_time = 10;


 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 TLC5926_LE1 = 1;
 TLC5926_LE2 = 1;
 TLC5926_NS = 1;
 TLC5926_nNS = 1;

 while(1){
 Intro();
 WriteText();
 WriteSpecialChars();
 WriteNumbers();
 }

}
